;---------------------------------------
;-     This Is The Music-Player of     -
;-             Digital Art             -
;-        Coded By Rene Lergner        -
;---------------------------------------

		;Crappy basic sys $0810 line
;for autostart with any C64 emulator 
		*= $0801
		.byte $0d,$08,$01,$00,$9e,$20
		.byte $24,$30,$38,$31,$30
		
         *= $0810

frstidx  sei
frsttime = *+1
player   lda #$00
         bne nofrsttm
         lda blckpnts
         sta pseudo0
         lda blckpnts+1
         sta pseudo1
         sta frsttime
pseudo0  = *+1
nofrsttm lda #$00
         sta blckpnts
pseudo1  = *+1
         lda #$00
         sta blckpnts+1
         lda #$01
         sta $d01a
         sta $dc0d
         lda #$00
         sta keybsong
         sta 650
         sta 198
         sta tunenr
         sta crsrpos
         sta rastmax
         sta denstpos
         sta timectrl
         bit $d011
         bpl *-3
         bit $d011
         bmi *-3
         jsr init
         jsr speeds
         lda #50
         sta timecnt
         lda #<irq
         sta $0314
         lda #>irq
         sta $0315
         lda #<text
         ldy #>text
         jsr $ab1e
         lda #$32
         sta $d012
         cli
keybsong = *+1
readkeys lda #$00
         beq stllplyr
         jmp keybinit
stllplyr jsr $ffe4
         cmp #$20
         bne nokeybrd
         sei
         jsr $e544
         lda #142
         jsr $ffd2
         ldx #$c5
copykeyb lda keybdata-1,x
         sta $03ff,x
         dex
         bne copykeyb
         jsr reset
         lda #<keybirq
         sta $0314
         lda #>keybirq
         sta $0315
         lda #<sfxblck
         sta blckpnts
         lda #>sfxblck
         sta blckpnts+1
         lda #$00
         sta octave
         sta denstpos
         lda #s00
         sta sfxblck
         sta keybsong
         lda #a00
         sta sfxblck+2
         lda #$7f
         sta $dc00
stillspc lda $dc01
         cmp #$ff
         bne stillspc
         cli
         jmp readkeys

nokeybrd cmp #133
         bne nozakint
         sei
         bit $d011
         bpl *-3
         bit $d011
         bmi *-3
         lda tunenr
         jsr init
         lda tunenr
         asl a
         asl a
         asl a
         tay
         lda tables+1,y
         lsr a
         lsr a
         lsr a
         lsr a
         sta denst
         lda #$30
         sta $04d9
         sta $04da
         sta $04dc
         sta $04dd
         lda #50
         sta timecnt
         lda #$00
         sta rastmax
         cli
         jmp readkeys
nozakint cmp #134
         bne nozakstp
         jsr reset
         jmp readkeys
nozakstp cmp #135
         bne nozakcnt
         sta control
         jmp readkeys
nozakcnt cmp #43
         bne notuneup
         inc tunenr
         lda tunenr
         cmp #$20
         bne readkey3
         dec tunenr
         jsr speeds
readkey3 jmp readkeys
notuneup cmp #45
         bne readkey3
         dec tunenr
         bpl readkey3
         inc tunenr
         jsr speeds
         jmp readkeys

speeds   lda tunenr
         asl a
         asl a
         asl a
         tax
         lda tables,x
         sta speedy
         lda tables+1,x
         lsr a
         lsr a
         lsr a
         lsr a
         sta denst
         rts

keybinit lda #$00
         sta 198
keybkeys jsr $ffe4
         beq *-3
         ldx #$1d
nextkey  dex
         bmi keybkeys
keypress cmp keyctrl,x
         bne nextkey
         txa
         cpx #$18
         bcs function
         ldx octave
         clc
         adc octadd,x
         sta sfxnote
         lda #$01
         sta inityn
readkey2 jmp readkeys

function cmp #$1c
         bne funct2
         lda #$7f
         sta $dc00
stllspc2 lda $dc01
         cmp #$ff
         bne stllspc2
         jmp player
funct2   cpx #$18
         bne nocrsrup
         ldx crsrpos
         beq keybkey2
         jsr cursor
         dex
         stx crsrpos
         jsr cursor
         bpl keybkey2
nocrsrup cpx #$19
         bne nocrsrdn
         ldx crsrpos
         cpx #$04
         beq keybkey2
         jsr cursor
         inx
         stx crsrpos
         jsr cursor
         bpl keybkey2
nocrsrdn stx $fb
         lda crsrpos
         asl a
         tax
         lda place,x
         sta $fc
         lda place+1,x
         sta $fd
         ldy #$00
         lda #$1a
         cmp $fb
         bne nocrsrlf
         lda ($fc),y
         cmp minmax,x
         beq keybkey2
         sec
         sbc #$01
         sta ($fc),y
         jmp keybkeys
nocrsrlf lda ($fc),y
         cmp minmax+1,x
         beq keybkey2
         clc
         adc #$01
         sta ($fc),y
keybkey2 jmp keybkeys

cursor   ldy line,x
         lda $041c,y
         eor #$1e
         sta $041c,y
         rts

crsrpos  .byte 0
line     .byte $00,$28,$50,$78,$a0
minmax   .byte s00,s1f,0,6,a00,a1f,0,3
         .byte 2,15
place    .word sfxblck,octave,sfxblck+2
         .word denst,speedy

d0111    = *+1
irq      lda #$1b
         sta $d011
d0121    = *+1
         lda #$00
         cmp $d012
rastctrl bne *-3
         sta raststrt
         nop
         nop
         inc $d020
         jsr play
         lda #$00
         sta $d020
         sta $d021
         inc $d019
         jsr playtime
         lda $dc00
         pha
nextffwd lda #$fe
         sta $dc00
         lda $dc01
         cmp #$f7
         bne noffwd
colorpos = *+1
         ldx #$00
         inx
         cpx #colorend-colors
         bne *+4
         ldx #$00
         lda colors,x
         sta $d020
         stx colorpos
         jsr playtme3
         jmp nextffwd
noffwd   pla
         sta $dc00
         lda #$00
         sta $d020
         lda tunenr
         lsr a
         lsr a
         lsr a
         lsr a
         tax
         lda hex,x
         sta $04d0
         lda tunenr
         and #$0f
         tax
         lda hex,x
         sta $04d1
         lda #$7f
         sta $dc00
         lda #$df
         cmp $dc01
         bne notrbass
         lda #$00
         sta 198
         jmp $9000
notrbass jsr dnstrast
         jmp $ea31

colors   .byte 13,5,12,11
colorend

playtme3 lda $d012
         sta raststrt
         jsr play
playtime lda $d012
         clc
raststrt = *+1
         sbc #$00
rastdecr = *+1
         sbc #$00
         cmp #$30
         bcs nomax
rastmax  = *+1
         cmp #$00
         bcc nomax
         sta rastmax
nomax    lda #$00
         sta rastdecr
         lda rastmax
         and #$0f
         tax
         lda hex,x
         sta $04eb
         lda rastmax
         lsr a
         lsr a
         lsr a
         lsr a
         tax
         lda hex,x
         sta $04ea
         lda control
         beq notmemax
         dec timectrl
         bpl notmemax
         lda denst
         sta timectrl
         dec timecnt
         bpl notmemax
         lda #49
         sta timecnt
         ldy #$03
playtme2 ldx timepos,y
         inc $04d9,x
         lda $04d9,x
         cmp timemax,y
         bne notmemax
         lda #$30
         sta $04d9,x
         dey
         bpl playtme2
notmemax rts

timepos  .byte 0,1,3,4
timemax  .byte $36,$3a,$36,$3a
timecnt  .byte 0
timectrl .byte 0

keybirq  inc $d019
d0112    = *+1
         lda #$1b
         sta $d011
d0122    = *+1
         lda #$00
         cmp $d012
         bne *-3
inityn   = *+1
         lda #$00
         beq normal
         lda #$00
         sta inityn
         lda tunenr
         jsr init
         lda #<sfxtrck
         sta trckposl
         lda #>sfxtrck
         sta trckposh
         lda #$01
         sta vceonoff
         jmp $ea7e
normal   jsr play
         lda sfxblck
         sec
         sbc #s00
         lsr a
         lsr a
         lsr a
         lsr a
         tax
         lda hex,x
         sta $0425
         lda sfxblck
         and #$0f
         tax
         lda hex,x
         sta $0426
         ldx octave
         lda hex,x
         sta $044d
         inx
         lda hex,x
         sta $044f
         lda sfxblck+2
         sec
         sbc #a00
         lsr a
         lsr a
         lsr a
         lsr a
         tax
         lda hex,x
         sta $0475
         lda sfxblck+2
         and #$0f
         tax
         lda hex,x
         sta $0476
         ldx denst
         stx density2
         lda hex,x
         sta $049e
         lda #$30
         sta $049d
         lda speedy
         lsr a
         lsr a
         lsr a
         lsr a
         tax
         lda hex,x
         sta $04c5
         lda speedy
         and #$0f
         tax
         lda hex,x
         sta $04c6
         txa
         lsr a
         sta speed1
         adc #$00
         sta speed2
         lda #$20
         sta $04d0
         sta $04d1
         sta $04ea
         sta $04eb
         sta $04d9
         sta $04da
         sta $04dc
         sta $04dd
         lda #$7f
         sta $dc00
         lda $dc01
         cmp #$df
         bne notback2
         lda #$00
         sta 198
         jmp $9000
notback2 jsr dnstrast
keyrdyn  = *+1
         jmp $ea31

octave   .byte 0
tunenr   .byte 0
octadd   .byte 0,12,24,36,48,60,72
hex      .text "0123456789"
		 .byte $01, $02, $03, $04, $05
		 .byte $06
keyctrl  .byte 81,50,87,51,69,82,53,84
         .byte 54,89,55,85,73,57,79,48
         .byte 80,64,45,42,92,94,19,20
         .byte $91,$11,$9d,$1d,$20
sfxtrck  .byte $00,$fe
sfxnote  = *+3
sfxblck  .byte s00,d1f,a00,c0,stp
text     .byte 147,14,150,163,48,32,31
		 .byte $20
		 .fill $20, $a4
		 .byte $20, $20
         .byte 150,48,163,163,49,32,31
         .byte 167,18,154
         .text "dIGITAL aRT mUSIC-pLAYE"
         .text "R V16.04!"
         .byte 146,159,165,150,32,49,163
         .byte 163,50,32,31,167,154,18
         .text "cODED bY tHE mIGHTY rE"
         .text "NE lERGNER"
         .byte 146,159,165,32,150,50,163
         .byte 163,51,32,32,159
		 .fill $20, $a3
		 .byte $20, $20
         .byte 150,51,163,163,52,13,157
         .byte 157,52,163,5
         .text "TUNE NR:    TIME:00.00 "
         .text " MAX.LINES:  "
         .byte 0

keybdata .byte $a0,$20,$a0,$20,$a0,$c2
         .byte $a0,$20,$a0,$20,$a0,$20
         .byte $a0,$c2,$a0,$20,$a0,$20
         .byte $a0,$c2,$a0,$20,$a0,$20
         .byte $a0,$03,$a0,$20,$3e,$09
         .byte $0e,$13,$14,$12,$2e,$20
         .byte $3a,$20,$20,$20,$a0,$32
         .byte $a0,$33,$a0,$c2,$a0,$35
         .byte $a0,$36,$a0,$37,$a0,$c2
         .byte $a0,$39,$a0,$30,$a0,$c2
         .byte $a0,$2d,$a0,$1c,$a0,$08
         .byte $a0,$20,$20,$0f,$03,$14
         .byte $01,$16,$05,$20,$3a,$20
         .byte $2b,$20,$a0,$c2,$a0,$c2
         .byte $a0,$c2,$a0,$c2,$a0,$c2
         .byte $a0,$c2,$a0,$c2,$a0,$c2
         .byte $a0,$c2,$a0,$c2,$a0,$c2
         .byte $a0,$c2,$a0,$c2,$89,$20
         .byte $20,$01,$12,$10,$0e,$12
         .byte $2e,$20,$3a,$20,$20,$20
         .byte $91,$c2,$97,$c2,$85,$c2
         .byte $92,$c2,$94,$c2,$99,$c2
         .byte $95,$c2,$89,$c2,$8f,$c2
         .byte $90,$c2,$80,$c2,$aa,$c2
         .byte $9e,$c2,$84,$20,$20,$04
         .byte $05,$0e,$13,$09,$14,$19
         .byte $3a,$20,$20,$20,$20,$20
         .byte $20,$20,$20,$20,$20,$20
         .byte $20,$20,$20,$20,$20,$20
         .byte $20,$20,$20,$20,$20,$20
         .byte $20,$20,$20,$20,$20,$20
         .byte $20,$20,$20,$13,$10,$05
         .byte $05,$04,$20,$20,$3a

;--------------------------basic player-

         *= $0f00

dnstrast lda #$7e
         sta keyrdyn
         dec denstpos
         bpl nonewscn
         lda #$31
         sta keyrdyn
         lda denst
         sta denstpos
         asl a
         tax
         lda inddenst,x
         sta $10
         lda inddenst+1,x
         sta $11
denstpos = *+1
nonewscn ldy #$00
         lda ($10),y
         sta d0121
         sta d0122
         sta d0123
         tya
         ora #$04
         tay
         lda ($10),y
         sta d0111
         sta d0112
         sta d0113
         ldx #$fa
         ldy #$d0
         and #$08
         beq *+7
         ldx d0121
         ldy #$90
         stx $d012
         sty rastctrl
         rts

getnr    jsr $aefd
         jsr $b79e
         txa
         rts
bscsfx   jsr getnr
         jmp sfxinit
bscinit  jsr getnr
         sei
         jsr init
         lda #<bscirq
         sta $0314
         lda #>bscirq
         sta $0315
         lda #$01
         sta $d01a
         sta $dc0d
         lda #$32
         sta $d012
         cli
         rts
d0113    = *+1
bscirq   lda #$1b
         sta $d011
d0123    = *+1
         lda #$32
         cmp $d012
         bne *-3
         nop
         nop
         inc $d020
         jsr play
         dec $d020
         jsr dnstrast
         inc $d019
         jmp $ea31

         *= $0fa0

         jmp play
         jmp reset
         jmp bscsfx
         jmp bscinit
         jsr getnr
         jmp vld

inddenst .word ds1,ds2,ds3,ds4
ds1      .byte $32,0,0,0,$1b
ds2      .byte $ce,$32,0,0,$1b,$1b
ds3      .byte 2,$9d,$32,0,$13,$1b,$1b
ds4      .byte $1c,$ce,$80,$32
         .byte $13,$1b,$1b,$1b
speedy   .byte 0
denst    .byte 0



;-------------------------SiD V2 Header-

;Defining PSID header
;To compile this routine with 64tass for sidplay
;remove the comment colon on the next line and
;remove all the content above the SiD V2 header
;separator. Run 64tass with -b parameter.
 
;		* = routine - $7e ;$7c + 2 bytes for loadaddress

offset	.text	"PSID"
		.byte	$00, $02	; version
		.byte	$00,$7c 	; data offset (loadaddress)
		.word 	0			; loadaddress is defined down below
initadr	.byte	>init,<init	; init address
playadr	.byte	>play,<play	; play address
		.byte	$00, $01	; song-count
		.byte	$00, $01	; start-song
		.byte	$00, $00	; speed bits next 16 songs
		.byte	$00, $00	; speed bits first 16 songs
title	.fill $20,0
author	.fill $20,0
cright	.fill $20,0
		* = title
		.text	"Lethal Noise Operator 2"
		* = title +$20
		.text	"Vincent Voois"
		* = title + $40
		.text	"1989-90 Focus"
		* = title + $66
loadadr	.word routine	;loadaddr

;--------------------------music player-

         *= $1000   ;start of the
                       ;music routine
zp       = $fe

routine  jmp play
         jmp reset
         jmp sfxinit
         jmp init

;------------------------------fade out-

vld      sta vldwnspd
         sta vldwnpos
         ldx #$00
         stx stpvldwn
         stx novolset
         inx
         stx trnvldwn
         rts

;-----------------------------tune init-

init     asl a
         asl a
         asl a
         tay
         jsr reset
         lda tables,y
         lsr a
         sta speed1
         adc #$00
         sta speed2
         lda tables+1,y
         and #$0f
         sta vceonoff
         lda tables+1,y
         lsr a
         lsr a
         lsr a
         lsr a
         sta density2
         lda #$0f
         sta volume
         sta novolset
nextinit iny
         iny
         lda tables,y
         sta trckposl,x
         lda tables+1,y
         sta trckposh,x
         jsr init2
         sta trackpos,x
         sta looppos,x
         sta noteadd,x
         sta instradd,x
         sta trnvldwn
         lda #$ff
         sta sfxblock,x
         txa
         clc
         adc #$07
         tax
         cmp #$15
         bne nextinit
         sta control
         rts

;------------------------------sfx init-

sfxinit  sta sfxpseu
         asl a
sfxpseu  = *+1
         adc #$00
         tay
         ldx #$00
         stx control
nxtvoice lda sfxpntrs,y
         bmi nosfxvce
         sta sfxblock,x
         jsr init2
nosfxvce iny
         txa
         clc
         adc #$07
         tax
         cmp #$15
         bne nxtvoice
         rts

;----------------------------------text-

         .text " music by digital art "

;---------------------------------------

init2    inc blcksplt,x
         lda #$00
         sta posindur,x
         sta speed,x
         sta dur,x
         sta blockpos,x
         sta nninit1,x
         sta nninit2,x
         rts

;---------------------------------reset-

reset    lda #$00
         sta control
         ldx #$16
clearsid lda #$08
         sta $d3ff,x
         dex
         bne clearsid
play3    rts

;----------------------------------play-

control  = *+1
play     lda #$00
         beq play3
vceonoff = *+1
         lda #$00
         sta vcepseu
         ldx #$00
         jsr play2
         ldx #$07
         jsr play2
         ldx #$0e
         jsr play2

;-------------------------------filters-

filtpos  = *+1
         ldy #$00
frstfilt = *+1
         lda #$00
         beq nofrstft
         lda fts,y
         and #$f0
         sta passes
         lda fts,y
         asl a
         asl a
         asl a
         asl a
         sta resnance
         lda fts+1,y
         sta filtlev
         lda #$00
         sta frstfilt
         beq end
nofrstft lda fltonoff
         ora fltonoff+7
         ora fltonoff+14
         bne nrmlfilt
         lda filtlink
         ora filtlink+7
         ora filtlink+14
         sta $d416
         bmi end
         sta $d417
         beq end
resnance = *+1
nrmlfilt ora #$00
         sta $d417
filtlev  = *+1
         lda #$00
         sta $d416
         ldx fts+2,y
         cpx #$fd
         beq stepdone
         bcs end
nonewval cmp fts+3,y
         bcs filtdown
         adc fts+2,y
         bcc notop
         lda #$ff
notop    cmp fts+3,y
         bcc end2
         bcs stepdone
filtdown sbc fts+2,y
         bcs nobottom
         lda #$00
nobottom cmp fts+3,y
         bcs end2
stepdone lda fts+3,y
         sta filtlev
         iny
         iny
         lda fts+2,y
         cmp #$ff
         bne noftgoto
         lda fts+3,y
         asl a
filtstrt = *+1
         adc #$00
         tay
noftgoto sty filtpos
         jmp end
end2     sta filtlev
trnvldwn = *+1
end      lda #$00
         beq novldwn3
         dec vldwnpos
         bpl novldwn3
vldwnspd = *+1
         lda #$00
         sta vldwnpos
         dec volume
         bne novldwn3
         lda #$00
         sta trnvldwn
stpvldwn = *+1
         lda #$00
         sta control
volume   = *+1
novldwn3 lda #$00
passes   = *+1
         ora #$00
         sta $d418
return   rts

;------------------------voice handling-

play2    dec vcepseu
         bpl voiceon
         lda sfxblock,x
         bmi return
voiceon  dec posindur,x
         bpl specfx2
         lda speed,x
         eor #$01
         sta speed,x
         bne speed3
speed1   = *+1
         lda #$00
         bpl speed4
speed2   = *+1
speed3   lda #$00
speed4   sta posindur,x
         inc durup,x
         dec dur,x
         lda dur,x
         cmp #$ff
         bne specfx2
         lda sfxblock,x
         bpl sfxon

;------------------------track handling-

         lda trckposl,x
         sta zp
         lda trckposh,x
         sta zp+1
         ldy trackpos,x
newstep2 lda (zp),y
         bpl block
         iny
         cmp #$fc
         bcc volset
         bne nofdout
         sta stpvldwn
         sta trnvldwn
         lda (zp),y
         iny
         sta vldwnspd
         sta vldwnpos
         bpl newstep2
nofdout  cmp #$fe
         bcc spdchnge
         bne trckgoto
         sta waveand,x
specfx2  jmp specfx
trckgoto lda (zp),y
         tay
         jmp newstep2
spdchnge lda (zp),y
         iny
         lsr a
         sta speed1
         adc #$00
         sta speed2
         bpl newstep2
volset   cmp #$e0
         bcc loop
novolset = *+1
         lda #$00
         beq newstep2
         and #$0f
         sta volume
         bne newstep2
loop     cmp #$c0
         bcc noteadd2
         and #$1f
         sta looppos,x
         bpl newstep2
noteadd2 cmp #$a0
         bcc instadd2
         and #$1f
         sta noteadd,x
         bpl newstep2
instadd2 and #$1f
         sta instradd,x
block    tya
         sta trackpos,x
         lda (zp),y
sfxon    asl a
         tay

;------------------------block handling-

         lda blckpnts,y
         sta zp
         lda blckpnts+1,y
         sta zp+1
         ldy blockpos,x
         lda momdur,x
         sta dur,x
sfxstart lda (zp),y
         cmp #$f0
         bcc norls
         and #$0f
         sta dur,x
         lda #$fe
         sta waveand,x
         jmp blckend2
norls
         lda nninit1,x
         sta nninit2,x
         and #$01
         bne holded
         sta $d404,x
density2 = *+1
         lda #$00
         sta density,x
holded   lda #$00
         sta durup,x
         sta gldspdl,x
         sta gldspdh,x
         sta wait,x
         sta blcksplt,x
         sta gldvibrl,x
         sta gldvibrh,x
         sta vibrud,x
         lda #$ff
         sta waveand,x

         lda (zp),y
         cmp #$e0
         bcc nowait
         sta wait,x
         and #$0f
         sta dur,x
         jmp blckend2
nowait   cmp #$65
         bne nohold
         iny
         lda (zp),y
         sta nninit1,x
         iny
         lda (zp),y
nohold   cmp #$c0
         bcc nosound
         sta filtchng,x
         and #$1f
         clc
         adc instradd,x
         asl a
         asl a
         asl a
         sta instrnr,x
         lda #$00
         sta sustrel,x
         iny
         lda (zp),y
nosound  cmp #$a0
         bcc nodur
         and #$1f
         sta dur,x
secnddur sta momdur,x
         iny
         lda (zp),y
         cmp #$a0
         bcc nodur
         sbc #$a0
         adc dur,x
         sta dur,x
         bne secnddur
nodur    cmp #$80
         bcc noarp
         and #$1f
         sta arpnr,x
         iny
         lda (zp),y
noarp    cmp #$70
         bcc nostchng
         sta sustrel,x
         iny
         lda (zp),y
nostchng cmp #$66
         bne nofltchg
         iny
         lda (zp),y
         sta filtchng,x
         iny
         lda (zp),y
nofltchg cmp #$63
         bcc nosfx
         bne sfxstop
         ldy #$00
         jmp sfxstart
sfxstop  lda #$ff
         sta sfxblock,x
         rts
nosfx    cmp #$60
         bcc noglide
         and #$01
         sta spcglide,x
         iny
         lda (zp),y
         sta glddelay,x
         iny
         lda (zp),y
         rol a
         asl gldspdh,x
         rol a
         asl gldspdh,x
         ora #$01
         sta gldspdl,x
         iny
         lda (zp),y
         adc noteadd,x
         sta note,x
         iny
         lda (zp),y
         adc noteadd,x
         sta endnote,x
         bpl blckend2
noglide  adc noteadd,x
         sta note,x
blckend2 iny
         lda (zp),y
         cmp #$67
         bne nohldend
         lda #$00
         sta nninit1,x
         iny
         lda (zp),y
nohldend cmp #$62
         bne blockend
         lda looppos,x
         beq eoloop
         dec looppos,x
         bpl noeob2
eoloop   inc trackpos,x
noeob2   ldy #$00
blockend tya
         sta blockpos,x
         rts

;------------------voice initialisation-

blckint2 inc blcksplt,x
         lda nninit2,x
         sta zp
         lda nninit1,x
         and #$80
         bne *+5
         sta nninit1,x

         lsr zp
         bcs notinit5
         lda #$00
         sta wavepos,x
         sta freqpos,x
notinit5
         lsr zp
         bcs notinit1
         lda #$ff
         sta calcdur,x
         sta $d405,x
         lda #$01
         sta $d404,x
         lda density2
         sta density,x
notinit1
         lsr zp
         bcs nofilt2
         lda filtchng,x
         bpl fltchngd
         lda sounds+4,y
fltchngd beq *+4
         bpl fltreset
         sta filtlink,x
         lda #$00
         beq nofilt1
fltreset sta filtpos
         sta filtstrt
         sta frstfilt
         lda voicebit,x
nofilt1  sta fltonoff,x
nofilt2
         lsr zp
         bcs notinit3
         lda sounds+5,y
         sta plspos,x
         sta plsstart,x
         tay
         cmp #$10
         bcc noplstbl
         lda pls+1,y
         lsr a
         lsr a
         lsr a
         lsr a
         sta plsmax,x
         lda pls+1,y
         and #$0f
         eor plsmax,x
         sta pulseeor,x
         lda pls+2,y
         sta plscount,x
         lda pls,y
noplstbl sta plspseuh,x
         lda #$00
         sta plspseul,x
         ldy instrnr,x
notinit3
         lsr zp
         bcs notinit4
         lda sounds+6,y
         and #$0f
         sta vibrspd,x
         lda sounds+6,y
         and #$70
         lsr a
         lsr a
         lsr a
         sta vibrlev2
         lsr a
         clc
vibrlev2 = *+1
         adc #$00
         sta vibrlev3
         ldy note,x
         lda freqlow+2,y
         sec
         sbc freqlow,y
         sta zp+1
         lda freqhigh+2,y
         sbc freqhigh,y
vibrlev3 = *+1
         bpl *
         lsr a
         ror zp+1
         lsr a
         ror zp+1
         lsr a
         ror zp+1
         lsr a
         ror zp+1
         lsr a
         ror zp+1
         lsr a
         ror zp+1
         lsr a
         ror zp+1
         sta vibrlevh,x
         lda zp+1
         sta vibrlevl,x
         ldy instrnr,x
notinit4
         lda sustrel,x
         beq nocalc
         asl a
         asl a
         asl a
         asl a
         sta sustain
         lda sounds+3,y
         and #$0f
sustain  = *+1
         ora #$00
         sta sustrel,x
nocalc
         ldy endnote,x
         lda note,x
         stx zp+1
         tax
         lda freqlow,y
         sec
         sbc freqlow,x
         sta minmaxps
         lda freqhigh,y
         sbc freqhigh,x
         ldx zp+1
         sta gminmaxh,x
minmaxps = *+1
         lda #$00
         sta gminmaxl,x
nogldint
         ldy arpnr,x
         lda arppntrs-1,y
         sta arppos,x
         tay
         lda arp00,y
         and #$0f
         sta arpspeed,x
         sta arpspdps,x
         lda arp00,y
         lsr a
         lsr a
         lsr a
         lsr a
         clc
         adc arppos,x
         sta arpgoto,x

return2  rts

;-----------------------special effects-

blckint3 jmp blckint2

specfx   lda density,x
         beq nodenst
         dec density,x
         rts
nodenst  ldy instrnr,x
         lda blcksplt,x
         beq blckint3
         lda wait,x
         bne return2
         inc calcdur,x
         bpl *+10
         lda calcdur,x
         and #$81
         sta calcdur,x

;---------------------------tick-remove-

         bne notick
         lda sounds+2,y
         sta $d405,x
         lda sustrel,x
         bne othrsstn
         lda sounds+3,y
othrsstn sta $d406,x
notick

;---------------------------gate on/off-

         lda nninit1,x
         and #$02
         bne nogate
         lda calcdur,x
         beq nogate
nogate2  lda sounds+7,y
         and #$0f
         cmp #$08
         bcs rlfrmend
         cmp durup,x
         bcc switch
         bcs nogate
rlfrmend eor #$0f
         cmp dur,x
         beq nogate
         bcc nogate
switch   lda #$fe
         sta waveand,x
nogate

;------------------------------arpeggio-

         ldy instrnr,x
         lda sounds+6,y
         and #$80
         beq noarp2
         lda arpnr,x
         beq noarp2
         ldy arppos,x
         dec arpspdps,x
         bpl noarpgto
         lda arpspeed,x
         sta arpspdps,x
         inc arppos,x
         lda arp00+2,y
         cmp #$80
         bne noarpgto
         lda arpgoto,x
         sta arppos,x
noarpgto lda arp00+1,y
noarp2   sta calcnote

;----------------------------wave table-

         ldy instrnr,x
         lda sounds,y
         tay
         and #$01
         beq tableon
         tya
         bne nowvfunc
tableon  lda waves,y
         sta zp
         lda waves+1,y
         sta zp+1
         ldy wavepos,x
         lda (zp),y
         cmp #$fe
         bcc nowvfunc
         bne wavegoto
         dey
         bpl aftwvfnc
wavegoto iny
         lda (zp),y
         tay
aftwvfnc lda (zp),y
nowvfunc sta waveform,x
         iny
         tya
         sta wavepos,x

;----------------------------note table-

         ldy instrnr,x
         lda sounds+1,y
         beq tableoff
         tay
         lda freqs-2,y
         sta zp
         lda freqs-1,y
         sta zp+1
         ldy freqpos,x
         lda (zp),y
         cmp #$fe
         bcc nofqfunc
         beq freqstop
         iny
         lda (zp),y
         tay
nofqfunc iny
         tya
         sta freqpos,x
freqstop dey
         lda (zp),y
         bpl tunable
         and #$7f
         tay
space    lda freqlow,y
         sta frqlow
         lda freqhigh,y
         sta frqhigh
         jmp pulse
tunable  clc
         adc calcnote
         sta calcnote
tableoff

;---------------------------------glide-

         lda gldspdl,x
         beq noglide2
         lda glddelay,x
         cmp durup,x
         bcs noglide2
         lda note,x
         cmp endnote,x
         bcs glddown
         lda gldvibrl,x
         adc gldspdl,x
         sta gldvibrl,x
         lda gldvibrh,x
         adc gldspdh,x
         sta gldvibrh,x
         lda #$90
endcheck sta bccbcs
         lda gldvibrl,x
         sec
         sbc gminmaxl,x
         lda gldvibrh,x
         sbc gminmaxh,x
bccbcs   bcc contgld
         lda #$00
         sta gldspdl,x
         sta gldvibrl,x
         sta gldvibrh,x
         lda endnote,x
         sta note,x
frqcalc2 jmp freqcalc
contgld  lda spcglide,x
         beq frqcalc2
         lda calcdur,x
         and #$01
         beq freqcalc
         ldy note,x
         bpl space
glddown  lda gldvibrl,x
         sbc gldspdl,x
         sta gldvibrl,x
         lda gldvibrh,x
         sbc gldspdh,x
         sta gldvibrh,x
         lda #$b0
         bne endcheck
noglide2

;-------------------------------vibrato-

         ldy instrnr,x
         lda sounds+6,y
         and #$7f
         beq novibr
         lda nninit2,x
         and #$10
         bne novbrdly
         lda sounds+7,y
         lsr a
         lsr a
         lsr a
         lsr a
         cmp durup,x
         bcs novibr
novbrdly lda vibrud,x
         beq vibrup
         lda gldvibrl,x
         sec
         sbc vibrlevl,x
         sta gldvibrl,x
         lda gldvibrh,x
         sbc vibrlevh,x
         jmp aftvibr
vibrup   lda gldvibrl,x
         clc
         adc vibrlevl,x
         sta gldvibrl,x
         lda gldvibrh,x
         adc vibrlevh,x
aftvibr  sta gldvibrh,x
         dec vibrspd,x
         bpl novibr
         lda sounds+6,y
         and #$0f
         sec
         rol a
         sta vibrspd,x
         lda vibrud,x
         eor #$01
         sta vibrud,x
novibr

;-----------------frequency calculation-

freqcalc lda note,x
         clc
calcnote = *+1
         adc #$00
         tay
         lda freqlow,y
         adc gldvibrl,x
         sta frqlow
         lda freqhigh,y
         adc gldvibrh,x
         sta frqhigh

;---------------------------------pulse-

pulse    ldy plspos,x
         cpy #$10
         bcc pulseend
         lda plspseuh,x
         sbc plsmax,x
         lda plspseul,x
         bcc pulseup
         sbc pls+3,y
         sta plspseul,x
         bcs pulsend2
         dec plspseuh,x
         bpl pulsend2
pulseup  adc pls+3,y
         sta plspseul,x
         bcc pulsend2
         inc plspseuh,x
pulsend2 lda plsmax,x
         cmp plspseuh,x
         bne pulsend3
         eor pulseeor,x
         sta plsmax,x
pulsend3 lda plscount,x
         cmp #$fe
         beq pulseend
         dec plscount,x
         bne pulseend
         iny
         iny
         lda pls+2,y
         cmp #$ff
         bne noplsgto
         lda pls+3,y
         asl a
         adc plsstart,x
         tay
noplsgto tya
         sta plspos,x
pulsend5 lda pls+2,y
         sta plscount,x
pulseend

;---------------------------pseudo copy-

         lda plspseuh,x
         sta $d403,x
         lda plspseul,x
         sta $d402,x
frqlow   = *+1
         lda #$00
         sta $d400,x
frqhigh  = *+1
         lda #$00
         sta $d401,x
         lda waveform,x
         and waveand,x
         sta $d404,x
         rts

;------------------------frequency data-

freqlow  .byte $16,$27,$38,$4b,$5f,$73
         .byte $8a,$a1,$ba,$d4,$f0,$0e
         .byte $2d,$4e,$71,$96,$bd,$e7
         .byte $13,$42,$74,$a9,$e0,$1b
         .byte $5a,$9b,$e2,$2c,$7b,$ce
         .byte $27,$85,$e8,$51,$c1,$37
         .byte $b4,$37,$c4,$57,$f5,$9c
         .byte $4e,$09,$d0,$a3,$82,$6e
         .byte $68,$6e,$88,$af,$eb,$39
         .byte $9c,$13,$a1,$46,$04,$dc
         .byte $d0,$dc,$10,$5e,$d6,$72
         .byte $38,$26,$42,$8c,$08,$b8
         .byte $a0,$b8,$20,$bc,$ac,$e4
         .byte $70,$4c,$84,$18,$10,$70
         .byte $40,$70,$40,$78,$58,$c8
         .byte $e0,$98,$08,$30,$20,$2e

freqhigh .byte $01,$01,$01,$01,$01,$01
         .byte $01,$01,$01,$01,$01,$02
         .byte $02,$02,$02,$02,$02,$02
         .byte $03,$03,$03,$03,$03,$04
         .byte $04,$04,$04,$05,$05,$05
         .byte $06,$06,$06,$07,$07,$08
         .byte $08,$09,$09,$0a,$0a,$0b
         .byte $0c,$0d,$0d,$0e,$0f,$10
         .byte $11,$12,$13,$14,$15,$17
         .byte $18,$1a,$1b,$1d,$1f,$20
         .byte $22,$24,$27,$29,$2b,$2e
         .byte $31,$34,$37,$3a,$3e,$41
         .byte $45,$49,$4e,$52,$57,$5c
         .byte $62,$68,$6e,$75,$7c,$83
         .byte $8b,$93,$9c,$a5,$af,$b9
         .byte $c4,$d0,$dd,$ea,$f8,$fd

;-------------------------------pseudos-

trackpos .byte 0
trckposl .byte 0
trckposh .byte 0
blockpos .byte 0
dur      .byte 0
sfxblock .byte 0
momdur   .byte 0

         .byte 0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0

gldvibrl .byte 0
gldvibrh .byte 0
gldspdh  .byte 0
glddelay .byte 0
spcglide .byte 0
plsstart .byte 0
arpnr    .byte 0

         .byte 0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0

fltonoff .byte 0
nninit2  .byte 0
note     .byte 0
noteadd  .byte 0
gminmaxh .byte 0
looppos  .byte 0
instrnr  .byte 0

         .byte 0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0

plspseul .byte 0
plspseuh .byte 0
pulseeor .byte 0
plsmax   .byte 0
instradd .byte 0
voicebit .byte 1
calcdur  .byte 0

         .byte 0,0,0,0,0,2,0
         .byte 0,0,0,0,0,4,0

durup    .byte 0
waveand  .byte 0
nninit1  .byte 0
waveform .byte 0
endnote  .byte 0
vibrud   .byte 0
vibrspd  .byte 0

         .byte 0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0

wavepos  .byte 0
sustrel  .byte 0
arppos   .byte 0
arpgoto  .byte 0
arpspeed .byte 0
arpspdps .byte 0
gminmaxl .byte 0

         .byte 0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0

vibrlevl .byte 0
vibrlevh .byte 0
gldspdl  .byte 0
blcksplt .byte 0
freqpos  .byte 0
posindur .byte 0
speed    .byte 0

         .byte 0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0

plscount .byte 0
plspos   .byte 0
wait     .byte 0
density  .byte 0
filtchng .byte 0
filtlink .byte 0
vldwnpos .byte 0 ;

         .byte 0,0,0,0,0,0
vcepseu  .byte 0 ;
         .byte 0,0,0,0,0,0

;---------------------------------------
;- This Is The End Of The Music-routy! -
;-   Here Starts The Real Music File   -
;---------------------------------------
;Following info added by vV/Focus:
;1st byte=song speed,higher means slower 
;2nd byte=density (hi nibble) 
; and track amount (low nibble)
;There should be a way to add more songs
;into this routine, but i forgot how.)
tables   .byte $04,$03

;pointers to track tables   
         .word t00,t01,t02

;--------------------------------tracks-
;Following info added by vV/Focus:
; trxx = transpose block x semitones (00-31)
; rxx = Repeat next block x times (00-31)
; combined commands like rxx, trxx are possible
; only if they all precede the blockreference 
; fdt,$xx = fadeout with speed xx, low = fast
; spd,$xx = set track tempo with val xx.
; hlt = halt track
; jpt, $xx = jump to position xx
; vsx supposed to be track volume but it doesn't 
; seem to work in any emulator.
; All other figures are referencing to their
; respective block numbers

t00      .byte r05,$00,r03,$03
         .byte tr12,$05,tr14,$05
         .byte tr00,$06
         .byte tr12,$05,tr14,$05
         .byte tr00,$06
         .byte tr12,$05,$ae,$05,$a0,$06
         .byte tr12,$05,$ae,$05,$a0,$06
         .byte tr12,$0a,$a0,$c5,$04
         .byte tr12,$05,tr14,$05,tr00
         .byte $06
         .byte tr12,$05,tr14,$05,tr00
         .byte $06
         .byte tr12,$0a,tr00
         .byte r15,tr01,$0d
         .byte tr12,$05,tr14,$05,tr00
         .byte $06
         .byte tr12,$05,tr14,$05,tr00
         .byte $06
         .byte tr12,$05,tr14,$05,tr00
         .byte $06
         .byte tr12,$05,tr14,$05,tr00
         .byte $06
         .byte tr12,$0a,tr00
         .byte jpt,$00

t01      .byte r09,$01,r03,$07,$0b
         .byte r07,$01,r03,$07,$0b
         .byte r03,$0e
         .byte r03,$07,$0b
         .byte jpt,$00

t02      .byte r03,$09,$04,$02,r01,tr12
         .byte $08,tr00,$0c,r03,$09,$02
         .byte r01,tr12,$08,tr00,$0c
         .byte r01,$04,r01,$0f
         .byte r01,tr12,$08,tr00,$0c
         .byte jpt,$00

;------------------------block pointers-

blckpnts .word b00,b01,b02,b03
         .word b04,b05,b06,b07
         .word b08,b09,b0a,b0b
         .word b0c,b0d,b0e,b0f

;--------------------------------blocks-
;Following info added by vV/Focus:
;sxx = Sound/instrument xx (00 - 1f)
;
;dxx = duration xx moments (00 - 1f)
;
;axx = arpeggio table xx (00 - 1f)
;
;fch,$xx = Filter change, 
; xx currently unknown reference.
;
;glide functions, put in front of notes:
;gld,xx,yy = Glide from note 1 to 2
; xx = delay, yy = speed 
;spc,xx,yy = space glide from note 1 to 2
;	   Note glides with an arpeggio
; xx = delay, yy = speed
; 
;Notesustain - put in front of note:
;snx = note-sustain x=0-f, low is soft
;
;rlx = note release, put behind note.
;
;hld,$xx = hold note? (this used to paste
;one note to the other without glide.)
;hld starts to give results if xx = $80 to 
;$8f. $90 - $ff are duplicate areas.
; Try $83 for note linking, $80 to reset gating
;
;hd0, dxx = hold previous note for xx duration
;
;wtx = wait x moments
;
;stp = stop
;
;Notes:c0 - b7, flat notes are double chars
; e.g. c#2 = cc2, g#4 = gg4, f#5 = ff5
;

b00      .byte s04,d1b,a01,a1,d03,c2,d1b
         .byte d2,d03,e2,stp

b01      .byte s07,d05,a04,a4,a4,d0f,a05
         .byte a4,d03,a4,d05,a06,a4,a4
         .byte d0f,a07,a4,d03,a4,stp

b02      .byte s09,d05,a4,b4,c5,d5,d03
         .byte e5,gld,$01,$30,dd5,e5,d05
         .byte gld,$01,$30,dd5,e5,d05,d5
         .byte d07,a4,d03,g4,e4,g4
         .byte d05,a4,b4,c5,d5,d03,e5
         .byte g5,d05
         .byte gld,$01,$30,gg5,a5,d03
         .byte gld,$01,$30,gg5,a5,d01,g5
         .byte d07,e5
         .byte s02,d01,c0,d03,c0,d01,c0
         .byte c0,c0,s09
         .byte d05,a4,b4,c5,d5,d03
         .byte e5,gld,$01,$30,dd5,e5,d05
         .byte gld,$01,$30,dd5,e5,d05,d5
         .byte d07,a4,d03,g4,e4,g4
         .byte d05,a4,a5,c5,b4,d03,g4
         .byte e4,d05
         .byte gld,$01,$30,cc4,d4,d03
         .byte gld,$01,$30,a3,c4,d01,a4
         .byte d07,g4
         .byte s02,d01,c0,d03,c0,d01,c0
         .byte c0,c0
         .byte stp

b03      .byte s08,d05,a00,a1,d01,a2
         .byte s02,a1,s08,e1,g1
         .byte e1,d05,a1,d01,a2,s02,e1
         .byte s08,e1,d03
         .byte c3,gld,$01,$30,cc2,d2
         .byte gld,$01,$30,cc3,d3
         .byte s02,d01,c0,s08
         .byte a1,c2,a1,d2,c1,d2,d01
         .byte gld,$01,$10,dd2,e2,s02
         .byte d01,c0,d03,c0,d01,c0,stp

b04      .byte s01,d07,c0,c0,c0,c0,c0,c0
         .byte c0,c0,c0,c0,c0,c0,c0,c0
         .byte d03,c0,c0,s02,d05,c0,d01
         .byte c0,stp

b05      .byte s08,d03,f0,f1,s02,f0,s08
         .byte f1,f0,f1,s02,f0,s08,f1
         .byte stp

b06      .byte s08,d03,a1,a2,s02,a1,s08
         .byte a2,a1,a2,s02,a1,s08,a2
         .byte a1,a2,s02,a1,s08,a2,a1
         .byte a2,s02,d01,c1,d03,c1,d01
         .byte a1,stp

b07      .byte s07,d05,a08,f4,f4,d07,f4
         .byte d03,f4,f4,f4,d05,g4,g4
         .byte d07,g4,d03,g4,g4,g4
         .byte s07,d05,a04,a4,a4,d07,a05
         .byte a4,d03,a4,a4,a4,d05,a04
         .byte a4,a4,d07,a05,a4,d03,a4
         .byte a4,a4,stp

b08      .byte s09,d07,gld,$01,$30
         .byte b3,c4,gld,$01,$30,c4
         .byte b3,gld,$01,$30,b3,c4
         .byte a3,b3,d03,c4,d07,b3
         .byte d03,a3,d07,g3,c4,d4,e4
         .byte d03,g4,d07,a00
         .byte gld,$01,$30,gg4,a4,d03
         .byte a4,g4,e4,d4,c4,g4,a4
         .byte s09,d03,gld,$01,$30
         .byte b3,c4,d4,e4,d07
         .byte gld,$01,$30
         .byte ff4,g4,d03,c4,e4,d07
         .byte d4,d03,c4,d4,c4,d4,c4,g4
         .byte d07,gld,$01,$30,gg4,a4
         .byte d03,a4,b4,b4,c5,d5
         .byte gld,$01,$30,dd5,e5,d07
         .byte gld,$01,$30,cc5,d5,d03
         .byte c5,s07,d01,d5,a4,c5,e4
         .byte d4,e4,d4,c4,d4,e4,a3,g3
         .byte stp

b09      .byte wt0,s07,d05,a04,a4
         .byte a4,d0f,a05,a4,d03,a4,d05
         .byte a06,a4,a4,d0f,a07,a4,d02
         .byte a4,stp

b0a      .byte s05,d01,e1,g1,a1,d03,c2
         .byte d01,d2,e2,d03,d2,d01,g2
         .byte e2,d03,a2,d01,g2,e2,d2
         .byte c2,dd2,d2,c2,dd2,c2,d2
         .byte d11,a1,stp

b0b      .byte s02,d01,c0,s00,c0,c0,s02
         .byte c0,s00,c0,c0,s02,c0,s00
         .byte c0
         .byte s02,d01,c0,s00,c0,c0,s02
         .byte c0,s00,c0,c0,s02,c0,s00
         .byte c0,s03,d05,c0,d03,c0,d05
         .byte c0,d07,c0,d07,c0,stp

b0c      .byte s07,d05,a02,a4,d03,a4
         .byte d01,a4,a4,d03,a04,a4
         .byte d01,a4,d03,a07,a4,s06
         .byte d03,a04,a4,d1f,d03,a05
         .byte a4,stp

b0d      .byte s08,d03,a1,a2,s02,a1,s08
         .byte a2,a1,a2,s02,a1,s08,a2
         .byte stp

b0e      .byte s07,d07,a03,aa4,aa4,aa4
         .byte aa4,c5,c5,c5,c5,cc5,cc5
         .byte cc5,cc5,dd5,dd5,dd5,dd5
         .byte stp

b0f      .byte s09,d13,f4,d03,d4,aa3
         .byte d17,g4,d03,e4,c4
         .byte d17,gg4,d03,f4,cc4
         .byte d17,aa4,d03,g4,d07,dd4
         .byte stp

;---------------------------------------
;- sounds : wf,fq,ad,sr,ft,ps,xx,yy    -
;-                                     -
;-     xx : bit 7       : arp on/off   -
;-          bit 4-6     : vibrato level-
;-          bit 0-3     : vibrato speed-
;-     yy : high nibble : vibrato delay-
;-          low  nibble : release delay-
;---------------------------------------
;Following info added by vV/Focus:
;1x = sine, 2x = saw, 4x = pulse, 8x = noise
;x = 0/2, inaudible (allows ringmod on other chan)
;x = 1, standard gate and attack
;x = 3/6, ringmod
;wxx = reference to drum pointers
;fxx = reference to dr.ptr frequency tables
;ftx = reference to filter table
;pxx = reference to pulse table
;wave, filt and pulse may contain fixed values
;Filter and frequency reference can be turned 
;off
;Pulse field requires a value or reference.

sounds   .byte w00,f00,$00,$e8 ;s00
         .byte off,$08,$00,$0f

         .byte w00,f01,$00,$ea ;s01
         .byte off,$08,$00,$0f

         .byte w01,f02,$00,$e7 ;s02
         .byte off,$08,$00,$0f

         .byte w02,f03,$09,$00 ;s03
         .byte off,$08,$00,$0f

         .byte $41,off,$07,$cf ;s04
         .byte ft0,p00,$80,$01

         .byte $41,off,$08,$a9 ;s05
         .byte ft1,p00,$31,$3e

         .byte w04,off,$08,$89 ;s06
         .byte $00,p01,$80,$0d

         .byte w05,f05,$08,$89 ;s07
         .byte off,p01,$80,$01

         .byte w03,f04,$08,$89 ;s08
         .byte off,p02,$32,$6d

         .byte $41,f06,$08,$89 ;s09
         .byte off,p02,$32,$6d

;-------------------------drum pointers-

waves    .word wv00,wv01,wv02,wv03
         .word wv04,wv05

freqs    .word fq00,fq01,fq02,fq03
         .word fq04,fq05,fq06

;-----------------------------drum data-
;Following info added by vV/Focus:
;wvXX, byte values are wave-form values
;fqXX, byte values are direct note values
;$fe = stop, 
;$ff,$xx = repeat from position xx
drmtbl	; Drumtables
wv00     .byte $81,$11,$11,$10,$fe
fq00     .byte $da,$a6,$a3,$9e,$9a
         .byte $97,$8b,$fe
fq01     .byte $da,$ac,$aa,$a8,$a6,$a3
         .byte $a0,$9d,$9a,$97,$80,$fe

wv01     .byte $81,$41,$80,$fe
fq02     .byte $da,$ac,$d8,$fe

wv02     .byte $81,$41,$41,$81,$81,$ff,0
fq03     .byte $da,$ab,$a7,$da,$dc,$ff,0

wv03     .byte $81
wv04     .byte $11,$41,$fe
fq04     .byte $da,$a8,$00,$fe

wv05     .byte $81,$41,$fe
fq05     .byte $da,$00,$fe

fq06     .byte $02,$01,$00,$fe

;---------------------------------pulse-
;Following info added by vV/Focus:
;Please note, the outcome has been measured 
;using an oscilloscope. If you understand the
;assembly language and see incorrect or missing
;info, feel free to correct or add it. 
;$xx,$yy =	Pulsewidth mod. xx = delay, 
;			y high nibble = sourceval, low = targetval
;If $xx =	8x = flat value x 1-8 pulsewith positive 1 =widest
;			flat value x 9-f pulsewith negative f =widest
;If $xx =	fe then yy = modulation speed (default yy = $40)
;If $xx =	ff then start from position yy (see flt table docs)

pls      = *-$10		;Pulse tables
pulse00  .byte $01,$48
         .byte $fe,$60
pulse01  .byte $0d,$6a
         .byte $03,$90
         .byte $fe,$60
pulse02  .byte $0d,$2e
         .byte $03,$80
         .byte $20,$40
         .byte $20,$20
         .byte $fe,$60
pulse03  .byte $88,$88   
         .byte $ff,$f0
pulse04
pulse05
pulse06
pulse07
pulse08
pulse09
pulse0a
pulse0b
pulse0c
pulse0d
pulse0e
pulse0f

;-------------------------------filters-
;Following info added by vV/Focus:
;Please note, the outcome has been measured 
;using an oscilloscope. If you understand the
;assembly language and see incorrect or missing
;info, feel free to correct or add it. 
;First line in each table:
;$xy,$zz	
;x = filter type, y = cutoff start
;$zz = filt-frequency offset
;following lines (line position starts here!):
;$xx, $yy
;$xx = speed to target filt-frequency
;$yy = target filt-freq.
;If $xx = fe, end of table
;If $xx = ff, then $yy is repeat position.

fts      = *-1			; filter tables
filt00   .byte $3f,$80	; Type plus cutoff start
         .byte $04,$40	; shift cutoff to $40 with speed 4 
         .byte $02,$04	; Shift cutoff to $04 with speed 2
         .byte $fe		; Stop
filt01   .byte $1f,$a0	; Type plus cutoff start
         .byte $10,$60	; shift cutoff to $60 with speed 10
         .byte $08,$10	; Shift cutoff to $10 with speed 8
         .byte $fe		; Stop
filt02   .byte $2f,$80
		 .byte $08,$20	;This is position 00!!
		 .byte $02,$80
         .byte $ff,$00	; Repeat from position 00filt02
filt03
filt04
filt05
filt06
filt07
filt08
filt09
filt0a
filt0b
filt0c
filt0d
filt0e
filt0f

;-----------------------------arpeggios-
;Following info added by vV/Focus:
; Arpeggio tables use relative note values
; First value sets arpeggio speed and repeatpos
; $xy: x = repeatpos, y = speed 
; Last value sets arpeggio end marker
; You can make arpeggios as long as you wish
; just take care to close it with $80

aptbl	; Arpeggio tables 
arp00    ;don't use arp00!!

arp01    .byte $02,$0c,$00,$00,$80
arp02    .byte $02,$00,$03,$07,$80
arp03    .byte $02,$00,$04,$07,$80
arp04    .byte $01,$00,$03,$07,$0a,$80 
arp05    .byte $01,$00,$03,$07,$09,$80
arp06    .byte $01,$00,$05,$07,$0a,$80
arp07    .byte $01,$00,$05,$07,$09,$80
arp08    .byte $01,$00,$04,$07,$09,$80
arp09
arp0a
arp0b
arp0c
arp0d
arp0e
arp0f
arp10
arp11
arp12
arp13
arp14
arp15
arp16
arp17
arp18
arp19
arp1a
arp1b
arp1c
arp1d
arp1e
arp1f

arppntrs .byte ap01,ap02,ap03,ap04,ap05
         .byte ap06,ap07,ap08;ap09,ap0a
         ;byte ap0b,ap0c,ap0d,ap0e,ap0f
         ;byte ap10,ap11,ap12,ap13,ap14
         ;byte ap15,ap16,ap17,ap18,ap19
         ;byte ap1a,ap1b,ap1c,ap1d,ap1e
         ;byte ap1f

;-----------------------------------sfx-
;Following info added by vV/Focus:
;The sfx pointers are actually for
;adding in-game sound effects.
;I have no idea how they work though
;only Heathcliff used them for creating
;the sfx for Tibo's Tale and i no longer
;have the original assembly source of the
;tibo's tale song.
sfxpntrs

;---------------------------------------
;- Editor Labels! Please Leave Them    -
;-     For What They Are!!!            -
;---------------------------------------

;wave table reference definitions
w00      = $00
w01      = $02
w02      = $04
w03      = $06
w04      = $08
w05      = $0a
w06      = $0c
w07      = $0e
w08      = $10
w09      = $12
w0a      = $14
w0b      = $16
w0c      = $18
w0d      = $1a
w0e      = $1c
w0f      = $1e
w10      = $20
w11      = $22
w12      = $24
w13      = $26
w14      = $28
w15      = $2a
w16      = $2c
w17      = $2e
w18      = $30
w19      = $32
w1a      = $34
w1b      = $36
w1c      = $38
w1d      = $3a
w1e      = $3c
w1f      = $3e

;filter reference table definitions
f00      = $02
f01      = $04
f02      = $06
f03      = $08
f04      = $0a
f05      = $0c
f06      = $0e
f07      = $10
f08      = $12
f09      = $14
f0a      = $16
f0b      = $18
f0c      = $1a
f0d      = $1c
f0e      = $1e
f0f      = $20
f10      = $22
f11      = $24
f12      = $26
f13      = $28
f14      = $2a
f15      = $2c
f16      = $2e
f17      = $30
f18      = $32
f19      = $34
f1a      = $36
f1b      = $38
f1c      = $3a
f1d      = $3c
f1e      = $3e
f1f      = $40

;filter block definitions
ft0      = filt00-fts
ft1      = filt01-fts
ft2      = filt02-fts
ft3      = filt03-fts
ft4      = filt04-fts
ft5      = filt05-fts
ft6      = filt06-fts
ft7      = filt07-fts
ft8      = filt08-fts
ft9      = filt09-fts
fta      = filt0a-fts
ftb      = filt0b-fts
ftc      = filt0c-fts
ftd      = filt0d-fts
fte      = filt0e-fts
ftf      = filt0f-fts

off      = $00
dep      = $ff

;pulse block definitions
p00      = pulse00-pls
p01      = pulse01-pls
p02      = pulse02-pls
p03      = pulse03-pls
p04      = pulse04-pls
p05      = pulse05-pls
p06      = pulse06-pls
p07      = pulse07-pls
p08      = pulse08-pls
p09      = pulse09-pls
p0a      = pulse0a-pls
p0b      = pulse0b-pls
p0c      = pulse0c-pls
p0d      = pulse0d-pls
p0e      = pulse0e-pls
p0f      = pulse0f-pls

;arpeggio block definitions
ap01     = arp01-arp00
ap02     = arp02-arp00
ap03     = arp03-arp00
ap04     = arp04-arp00
ap05     = arp05-arp00
ap06     = arp06-arp00
ap07     = arp07-arp00
ap08     = arp08-arp00
ap09     = arp09-arp00
ap0a     = arp0a-arp00
ap0b     = arp0b-arp00
ap0c     = arp0c-arp00
ap0d     = arp0d-arp00
ap0e     = arp0e-arp00
ap0f     = arp0f-arp00
ap10     = arp10-arp00
ap11     = arp11-arp00
ap12     = arp12-arp00
ap13     = arp13-arp00
ap14     = arp14-arp00
ap15     = arp15-arp00
ap16     = arp16-arp00
ap17     = arp17-arp00
ap18     = arp18-arp00
ap19     = arp19-arp00
ap1a     = arp1a-arp00
ap1b     = arp1b-arp00
ap1c     = arp1c-arp00
ap1d     = arp1d-arp00
ap1e     = arp1e-arp00
ap1f     = arp1f-arp00

;arp reference table definitions
a00      = $80
a01      = $81
a02      = $82
a03      = $83
a04      = $84
a05      = $85
a06      = $86
a07      = $87
a08      = $88
a09      = $89
a0a      = $8a
a0b      = $8b
a0c      = $8c
a0d      = $8d
a0e      = $8e
a0f      = $8f
a10      = $90
a11      = $91
a12      = $92
a13      = $93
a14      = $94
a15      = $95
a16      = $96
a17      = $97
a18      = $98
a19      = $99
a1a      = $9a
a1b      = $9b
a1c      = $9c
a1d      = $9d
a1e      = $9e
a1f      = $9f

;instrument table definitions
s00      = $c0
s01      = $c1
s02      = $c2
s03      = $c3
s04      = $c4
s05      = $c5
s06      = $c6
s07      = $c7
s08      = $c8
s09      = $c9
s0a      = $ca
s0b      = $cb
s0c      = $cc
s0d      = $cd
s0e      = $ce
s0f      = $cf
s10      = $d0
s11      = $d1
s12      = $d2
s13      = $d3
s14      = $d4
s15      = $d5
s16      = $d6
s17      = $d7
s18      = $d8
s19      = $d9
s1a      = $da
s1b      = $db
s1c      = $dc
s1d      = $dd
s1e      = $de
s1f      = $df

;duration table definitions
d00      = $a0
d01      = $a1
d02      = $a2
d03      = $a3
d04      = $a4
d05      = $a5
d06      = $a6
d07      = $a7
d08      = $a8
d09      = $a9
d0a      = $aa
d0b      = $ab
d0c      = $ac
d0d      = $ad
d0e      = $ae
d0f      = $af
d10      = $b0
d11      = $b1
d12      = $b2
d13      = $b3
d14      = $b4
d15      = $b5
d16      = $b6
d17      = $b7
d18      = $b8
d19      = $b9
d1a      = $ba
d1b      = $bb
d1c      = $bc
d1d      = $bd
d1e      = $be
d1f      = $bf

;wait values
wt0      = $e0
wt1      = $e1
wt2      = $e2
wt3      = $e3
wt4      = $e4
wt5      = $e5
wt6      = $e6
wt7      = $e7
wt8      = $e8
wt9      = $e9
wta      = $ea
wtb      = $eb
wtc      = $ec
wtd      = $ed
wte      = $ee
wtf      = $ef

sn0      = $70
sn1      = $71
sn2      = $72
sn3      = $73
sn4      = $74
sn5      = $75
sn6      = $76
sn7      = $77
sn8      = $78
sn9      = $79
sna      = $7a
snb      = $7b
snc      = $7c
snd      = $7d
sne      = $7e
snf      = $7f

c0       = $00
cc0      = $01
d0       = $02
dd0      = $03
e0       = $04
f0       = $05
ff0      = $06
g0       = $07
gg0      = $08
a0       = $09
aa0      = $0a
b0       = $0b

c1       = $0c
cc1      = $0d
d1       = $0e
dd1      = $0f
e1       = $10
f1       = $11
ff1      = $12
g1       = $13
gg1      = $14
a1       = $15
aa1      = $16
b1       = $17

c2       = $18
cc2      = $19
d2       = $1a
dd2      = $1b
e2       = $1c
f2       = $1d
ff2      = $1e
g2       = $1f
gg2      = $20
a2       = $21
aa2      = $22
b2       = $23

c3       = $24
cc3      = $25
d3       = $26
dd3      = $27
e3       = $28
f3       = $29
ff3      = $2a
g3       = $2b
gg3      = $2c
a3       = $2d
aa3      = $2e
b3       = $2f

c4       = $30
cc4      = $31
d4       = $32
dd4      = $33
e4       = $34
f4       = $35
ff4      = $36
g4       = $37
gg4      = $38
a4       = $39
aa4      = $3a
b4       = $3b

c5       = $3c
cc5      = $3d
d5       = $3e
dd5      = $3f
e5       = $40
f5       = $41
ff5      = $42
g5       = $43
gg5      = $44
a5       = $45
aa5      = $46
b5       = $47

c6       = $48
cc6      = $49
d6       = $4a
dd6      = $4b
e6       = $4c
f6       = $4d
ff6      = $4e
g6       = $4f
gg6      = $50
a6       = $51
aa6      = $52
b6       = $53

c7       = $54
cc7      = $55
d7       = $56
dd7      = $57
e7       = $58
f7       = $59
ff7      = $5a
g7       = $5b
gg7      = $5c
a7       = $5d
aa7      = $5e
b7       = $5f

;release value
rl0      = $f0
rl1      = $f1
rl2      = $f2
rl3      = $f3
rl4      = $f4
rl5      = $f5
rl6      = $f6
rl7      = $f7
rl8      = $f8
rl9      = $f9
rla      = $fa
rlb      = $fb
rlc      = $fc
rld      = $fd
rle      = $fe
rlf      = $ff

hd0      = $67
fch      = $66	
hld      = $65	;hld (sustain) note
fxs      = $64	;fx stop
fxr      = $63	;fx repeat
stp      = $62	;stop
spc      = $61  ;space glide from note x to y
gld      = $60  ;glide from note x to y

;volume set
vs0      = $e0
vs1      = $e1
vs2      = $e2
vs3      = $e3
vs4      = $e4
vs5      = $e5
vs6      = $e6
vs7      = $e7
vs8      = $e8
vs9      = $e9
vsa      = $ea
vsb      = $eb
vsc      = $ec
vsd      = $ed
vse      = $ee
vsf      = $ef

;Repeat reference table (vV addon)
r00		 = $c0
r01		 = $c1
r02		 = $c2
r03		 = $c3
r04		 = $c4
r05		 = $c5
r06		 = $c6
r07		 = $c7
r08		 = $c8
r09		 = $c9
r10		 = $ca
r11		 = $cb
r12		 = $cc
r13		 = $cd
r14		 = $ce
r15		 = $cf
r16		 = $d0
r17		 = $d1
r18		 = $d2
r19		 = $d3
r20		 = $d4
r21		 = $d5
r22		 = $d6
r23		 = $d7
r24		 = $d8
r25		 = $d9
r26		 = $da
r27		 = $db
r28		 = $dc
r29		 = $dd
r30		 = $de
r31		 = $df

;Transpose reference table (vV addon)
tr00		 = $a0
tr01		 = $a1
tr02		 = $a2
tr03		 = $a3
tr04		 = $a4
tr05		 = $a5
tr06		 = $a6
tr07		 = $a7
tr08		 = $a8
tr09		 = $a9
tr10		 = $aa
tr11		 = $ab
tr12		 = $ac
tr13		 = $ad
tr14		 = $ae
tr15		 = $af
tr16		 = $b0
tr17		 = $b1
tr18		 = $b2
tr19		 = $b3
tr20		 = $b4
tr21		 = $b5
tr22		 = $b6
tr23		 = $b7
tr24		 = $b8
tr25		 = $b9
tr26		 = $ba
tr27		 = $bb
tr28		 = $bc
tr29		 = $bd
tr30		 = $be
tr31		 = $bf

fdt      = $fc	;fade out
spd      = $fd	;block speed
hlt		 = $fe	;stop track playing	
jpt		 = $ff	;jump to


